﻿using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WG_IntegerToHHMM
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("ID", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Time", typeof(int));

            dt.Rows.Add(new object[] { null, 123 });
            dt.Rows.Add(new object[] { null, 433 });
            dt.Rows.Add(new object[] { null, 543 });
            dt.Rows.Add(new object[] { null, 732 });
            dt.Rows.Add(new object[] { null, 113 });
            dt.Rows.Add(new object[] { null, 662 });
            dt.Rows.Add(new object[] { null, 153 });

            ultraGrid1.DataSource = dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var unboundColumn = e.Layout.Bands[0].Columns.Add("Time_Unbound");
            
            unboundColumn.Editor = new EditorWithMask();
            unboundColumn.Header.Caption = "Time";
            unboundColumn.DataType = typeof(DateTime);
            unboundColumn.MaskInput = "hh:mm";
            unboundColumn.Format = "HH:mm";
            
            e.Layout.Bands[0].Columns["Time"].Hidden = true;
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (e.ReInitialize)
            {
                var unboundValue = (DateTime)e.Row.Cells["Time_Unbound"].Value;
                e.Row.Cells["Time"].Value = unboundValue.Hour * 3600 + unboundValue.Minute * 60;
            }
            else
            {
                e.Row.Cells["Time_Unbound"].Value = DateTime.Today.AddSeconds((int)e.Row.Cells["Time"].Value);
            }
        }
    }
}
